import json
import serial
import urllib.request
import serial.tools.list_ports

class Communication():
    def __init__(self,com,bps,timeout):
        self.port = com
        self.bps = bps
        self.timeout =timeout
        global Ret
        try:
             self.main_engine= serial.Serial(self.port,self.bps,timeout=self.timeout)
             if (self.main_engine.is_open):
               Ret = True
        except Exception as e:
            print("---异常---：", e)

    def Open_Engine(self):
        self.main_engine.open()

    def Close_Engine(self):
        self.main_engine.close()
        print(self.main_engine.is_open) 

    @staticmethod
    def Print_Used_Com():
        port_list = list(serial.tools.list_ports.comports())
        print(port_list)

    def Read_Size(self,size):
        return self.main_engine.read(size=size)

    def Read_Line(self):
        return self.main_engine.readline()

    def Send_data(self,data):
        self.main_engine.write(data)

    def Recive_data(self):
        print("开始接收数据：")
        while True:
            try:
                if self.main_engine.in_waiting:
                    data=self.main_engine.readline().decode("gbk")
                    result=json.loads(data)
                    #result1=result["obj"][0]["type"]
                    result1=result["obj"][0]
                    print(result1)
                    url="https://open.myfpga.cn/unitv2/?data="+urllib.parse.quote(json.dumps(result1))
                    req=urllib.request.Request(url)
                    resp=urllib.request.urlopen(req)
                    data=resp.read().decode('utf-8')
            except Exception as e:
                print("异常报错：",e)


Communication.Print_Used_Com()
Ret =False

Engine1 = Communication("com2",115200,0.5)#在此修改端口
if (Ret):
    Engine1.Recive_data()
